module AdebeoOptisketchRapport
  class Ligneanalyser
    
      attr_accessor :entite, :niveau,:pere,:nom,:longueur,:largeur,:hauteur,:matiere,:qIntraPere, :qTotalModel, :transformation, :longueurReel, :hauteurReel, :largeurReel, :aCompter,:lastLevel, :aAfficher
  	
    	def initialize(entite,niveau,pere,transformation,options)
    	    @@options = options
          @entite = entite 
          @niveau = niveau
          @pere = pere
          @transformation = transformation
          @qIntraPere = 1
          @qTotalModel = 1
          @lastLevel = true
          @aCompter = true
          @aAfficher = true
          if entite.is_a? Sketchup::ComponentInstance
            if entite.name != ""
              @nom = entite.name
            else
              @nom = entite.definition.name
            end
          else
            @nom = entite.name
          end
        
          dimensionInterne
          dimensionReel
        
          if entite.is_a? Sketchup::Model
            @matiere = ""
          else  
            if entite.material != nil
              @matiere= entite.material.name
            else
              @matiere = ""
            end
          end

      end
    
      def elementComptage(option = 0)
          return [@nom]
      end
    
      def dimensionInterne
        bb = @entite.bounds
        @longueur = bb.width
        @hauteur= bb.depth
        @largeur = bb.height
      end
    
      def dimensionReel
        if pere != nil
          a = pere.transformation.to_a
        else
          a = [1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0]
        end
        xspot=[a[0],a[1],a[2]]
    		yspot=[a[4],a[5],a[6]]
    		zspot=[a[8],a[9],a[10]]
    		lorigM=[0,0,0]
    		scaleX=(lorigM.distance xspot).to_f
    		scaleY=(lorigM.distance yspot).to_f
    		scaleZ=(lorigM.distance zspot).to_f
        longueurReel = @longueur *scaleX
        hauteurReel = @hauteur * scaleY
        largeurReel = @largeur *scaleZ
        longueurReelTrie =largeurReelTrie=hauteurReelTrie= 0.0
        case @@options[:sensDuFil][:defauls].to_i
          when 0
            longueurReelTrie = longueurReel
            largeurReelTrie = largeurReel
            hauteurReelTrie = hauteurReel        
          when 1
            dimensions = [longueurReel,hauteurReel,largeurReel].sort
            longueurReelTrie = dimensions[2]
            largeurReelTrie = dimensions[1]
            hauteurReelTrie = dimensions[0]
          when 2
            longueurReelTrie = largeurReel
            largeurReelTrie = longueurReel
            hauteurReelTrie = hauteurReel
          when 3
            texture = false
            if @entite.material != nil
              if @entite.material.texture != nil
                texture = true
              end
            end
            if texture
              longueurReelTrie = longueurReel
              largeurReelTrie = largeurReel
              hauteurReelTrie = hauteurReel
            else
              dimensions = [longueurReel,hauteurReel,largeurReel].sort
              longueurReelTrie = dimensions[2]
              largeurReelTrie = dimensions[1]
              hauteurReelTrie = dimensions[0]
            end
        end
        #puts longueurReelTrie.inspect
        @longueurReel = formateLongueur(longueurReelTrie)
        @hauteurReel = formateLongueur(hauteurReelTrie)
        @largeurReel = formateLongueur(largeurReelTrie)     

      end

      def formateLongueur(valeur)

          case @@options[:unite][:defauls].to_i
          when 0
            valeurAvecUnite = valeur.to_f
          when 1
            valeurAvecUnite = valeur.to_feet.to_f
          when 2
            valeurAvecUnite = valeur.to_mm.to_f
          when 3
            valeurAvecUnite = valeur.to_cm.to_f
          when 4
            valeurAvecUnite = valeur.to_m.to_f
          end
          valeurArrondi = round_by(valeurAvecUnite,@@options[:nbdecimal][:defauls].to_i)
          valleurArrondiString = valeurArrondi.to_s.gsub("~ ","")
          return valleurArrondiString
      end
    
      def filtreDeComptage
        case @@options[:elementDeRegroupement][:defauls].to_i
        when 0
          return @nom.to_s
        when 1
          return @nom.to_s+@longueurReel+@hauteurReel+@largeurReel
        when 2
  		if pere != nil
  			return @nom.to_s+@longueurReel+@hauteurReel+@largeurReel+@pere.nom
  		else
  			return @nom.to_s+@longueurReel+@hauteurReel+@largeurReel+""
  		end
        when 3
          return @longueurReel+@hauteurReel+@largeurReel
        when 4
          return @longueurReel+@hauteurReel+@largeurReel+@matiere
        when 5
          return @longueurReel+@largeurReel
        when 6
          return @longueurReel+@largeurReel+@matiere
        when 7
          return @longueurReel
        when 8
          return @longueurReel+@matiere
        end
      end    
    
      def getAttributExporte
      
        label = []
        atributs =[]
      
        if @@options[:typeExport][:defauls].to_i != 1
          label << "Layer"
          atributs << @niveau
        end
      
        if @@options[:typeExport][:defauls].to_i != 2
          label << "Q Total"
          atributs << @qTotalModel
        else
          label << "Q Anzahl"
          atributs << @qIntraPere
        end
            
        case @@options[:elementDeRegroupement][:defauls].to_i
          when 0 #Nom
            label += ["Anzahl","Länge Erst","Breite Erst","Dicke Erst","Material Erst"]
            atributs += [@nom,@longueurReel, @largeurReel, @hauteurReel, @matiere]
          when 1 #Nom et dimension
            label += ["Anzahl","Länge","Breite","Dicke","Material"]
            atributs += [@nom,@longueurReel, @largeurReel, @hauteurReel, @matiere]
          when 2 #Nom Dimension et Parent
            label += ["Fuss","Zoll","Länge","Breite","Dicke","Material Erst"]
  		  if @parent != nil
  			atributs += [@parent.nom,@nom,@longueurReel, @largeurReel, @hauteurReel, @matiere]
  		  else
  			atributs += [" ",@nom,@longueurReel, @largeurReel, @hauteurReel, @matiere]
  		  end
          when 3 #Dimension
            label += ["Länge","Breite","Dicke"]
            atributs += [@longueurReel, @largeurReel, @hauteurReel]
          when 4 #Dimensions et matiere
            label += ["Länge","Breite","Dicke","Material"]
            atributs += [@longueurReel, @largeurReel, @hauteurReel, @matiere]
          when 5 #Longueur Largeur
            label += ["Länge","Breite"]
            atributs += [@longueurReel, @largeurReel]          
          when 6 #|Longueur Largeur Matiere
            label += ["Länge","Breite","Material"]
            atributs += [@longueurReel, @largeurReel, @matiere]
          when 7 #Longueur
            label += ["Länge"]
            atributs += [@longueurReel]
          when 8 #Longueur Matiere 
            label += ["Länge","Material"]
            atributs += [@longueurReel,@matiere]
        end
        return [atributs,label]
      end
    
      def getheader
        html ="<tr>"
        atributs = getAttributExporte[1]       
        atributs.each{|attribu| 
          html +="<th>"
          html += attribu.to_s
          html += "</th>"
        }
        html +="</tr>"
        return html
      end
    
      def gethtml
        atributs = getAttributExporte[0]
       
        html ="<tr class=\"niveau#{@niveau}\">"
        atributs.each{|attribu| 
          html +="<td>"
          html += attribu.to_s
          html += "</td>"
        }
        html +="</tr>"
        return html
      end

      def getCSV
        csv =""
        atributs = getAttributExporte[0]
        atributs.each{|attribu| 
          csv += attribu.to_s
          csv += ";"
        }
        csv +="
  "
        return csv
      end
        
      def round_by(value,precision)
        if precision != 0
    		  return (value * 10 ** precision).round.to_f / 10 ** precision
  		  else
  		    return (value * 10 ** precision).round.to_i / 10 ** precision
  		  end
    	end
    
  end

  class RapportAdebeo
  
    def initialize()
      @@options = AdebeoOptisketch.optisketchOption
      @typeExport = @@options[:elementMasque][:defauls].to_s
      @niveauExporte = @@options[:niveauExporte][:defauls].to_i
      @panneaux = @@options[:panneaux][:defauls].to_s
      @sensDuFil = @@options[:sensDuFil][:defauls].to_s    
    
      @listeLignes = []
    
      exploreModel # filtre si il s agit d un niveau precis sur le niveau     
    
      if @@options[:elementMasque][:defauls] == 1
        decompteLesElementMasque # passe les element masque a aCompter a false
        #trace("decompteLesElementMasque")
      end
    
      if @@options[:calqueMasque][:defauls] == 1
        decompteLesElementsSurLesCalqueInvisible # passe les element sur calque invisible a aCompter a false
        #trace("decompteLesElementsSurLesCalqueInvisible")
      end
    
      if @@options[:elementMasque][:defauls] == 1 || @@options[:calqueMasque][:defauls] == 1
        faitHeriteDesElemtnNonCompte # fait heriter les aCompter aux enfants
        #trace("faitHeriteDesElemtnNonCompte")
      end
    
      compteLesQuantiteIntraComposant # calcul les quantite des fils des element ayant des parents
      #trace("compteLesQuantiteIntraComposant")
    
      filtreLesLigneEnFonctionDesNiveaux # passe aAfficher à false en fonction du type d eport
      #trace("filtreLesLigneEnFonctionDesNiveaux")
    
      compteLesQuantiteTotal
      #trace("compteLesQuantiteTotal")
          
      @html = definitLawebDialogue
    
      afficheLaWebDialogue
    
    end
  
    def trace(message = "Liste anzeigen")
      listeAAfficher = @listeLignes.select{|ligne| [ligne.aCompter,ligne.aAfficher] == [true,true]}
      puts message + listeAAfficher.length.to_s     
    end
  
    def exploreModel
      # eplore l ensemble des lignes pour creer une liste sans quantites
      exploreEntite(Sketchup.active_model,0,nil)
    end
  
    def exploreEntite(entite,niveau,pere,transf = Geom::Transformation.new([0,0,0]))
      #creer un ligne pour l entite et regarde si il faut explorer les lignes inferieures
      ligne = Ligneanalyser.new(entite,niveau,pere,transf,@@options)
      @listeLignes << ligne
      niveau += 1
      #entie doit etre un model un group ou un composant
      if entite.is_a? Sketchup::ComponentInstance
        ents = entite.definition.entities
      else
        ents = entite.entities
      end
      lesComposants = ents.grep(Sketchup::ComponentInstance)
  	  lesGroupes = ents.grep(Sketchup::Group)
    	lesInstanceaExplorer = lesComposants + lesGroupes
  	
    	if @@options[:niveauExporte][:defauls].to_i < niveau && @@options[:typeExport][:defauls].to_i == 0
    	  lesInstanceaExplorer = []
    	end
  	
    	if lesInstanceaExplorer != []
    	  ligne.lastLevel = false
      	lesInstanceaExplorer.each{|fils|
      	  transformationGlobal = transf * fils.transformation
      	  exploreEntite(fils,niveau,ligne,transformationGlobal)
      	}   
      end
    
    end

    def decompteLesElementMasque
      @listeLignes.each{|ligne|
        if not ligne.entite.is_a? Sketchup::Model
          if ligne.entite.hidden?
            ligne.aCompter = false
          end
        end
      }
    end
  
    def decompteLesElementsSurLesCalqueInvisible
      @listeLignes.each{|ligne|
        if not ligne.entite.is_a? Sketchup::Model        
          if not ligne.entite.layer.visible?
            ligne.aCompter = false
          end
        end
      }
    end
  
    def faitHeriteDesElemtnNonCompte
      listeDesParents = @listeLignes.select{|ligne|ligne.lastLevel == false}
      listeDesParents.sort! {|a,b| a.niveau <=> b.niveau}
      listeDesParents.each{|ligne|
        if ligne.aCompter == false
          listeDeEnfant = @listeLignes.select{|ligneEnCours| ligneEnCours.pere == ligne }
          listeDeEnfant.each{|enfant| enfant.aCompter = false}
        end
      }
    end

    def compteLesQuantiteIntraComposant
      lesParents = @listeLignes.select{|ligne| ligne.lastLevel == false}
      lesParents.each{|parent|
        lesEnfantsDunParent = @listeLignes.select{|ligne| ligne.pere == parent}
        lesEnfantsDunParent.sort!{|a,b| a.filtreDeComptage <=> b.filtreDeComptage}
        lesEnfantsDunParent.each{|enfant|
           if enfant.aAfficher == true
            lesEnfantsAvecLememeNom = lesEnfantsDunParent.select{|ligne| ligne.filtreDeComptage == enfant.filtreDeComptage}
            lesEnfantsAvecLememeNomACompte = lesEnfantsAvecLememeNom.select{|ligne| ligne.aCompter == true}
            enfant.qIntraPere = lesEnfantsAvecLememeNomACompte.length
            lesEnfantsAvecLememeNomACompte.each{|enfantsAvecLememeNomACompte| enfantsAvecLememeNomACompte.aAfficher = false}
            enfant.aAfficher = true
          end
        }
      }
    end

    def filtreLesLigneEnFonctionDesNiveaux()
      # filtre les lignes selon les option de filtre
      if @@options[:typeExport][:defauls].to_i == 2
        ligneaPasafficher = []
      elsif @@options[:typeExport][:defauls].to_i == 1
        #puts "here"
        ligneaPasafficher = @listeLignes.select{|ligne| ligne.lastLevel != true}
      else
        ligneaPasafficher = @listeLignes.select{|ligne| ligne.niveau != @niveauExporte}
      end
      ligneaPasafficher.each{|ligne|ligne.aAfficher = false}
    end
  
    def compteLesQuantiteTotal
      @listeLignes.each{|ligneEnCour|
          if ligneEnCour.aAfficher == true
            lesLignesAvecLeMemeNom = @listeLignes.select{|ligne| ligne.filtreDeComptage == ligneEnCour.filtreDeComptage}
            lesLignesAvecLeMemeNomACompte = lesLignesAvecLeMemeNom.select{|ligne| [ligne.aCompter,ligne.aAfficher] == [true,true]}      
            q = 0
            lesLignesAvecLeMemeNomACompte.each{|lignesAvecLeMemeNomACompte| q += lignesAvecLeMemeNomACompte.qIntraPere
              lignesAvecLeMemeNomACompte.aAfficher = false
            }
            ligneEnCour.aAfficher = true
            ligneEnCour.qTotalModel = q
          end
      }
    end
  
    def enleveLesDoublons
      listeAAfficher = @listeLignes.select{|ligne| [ligne.aCompter,ligne.aAfficher] == [true,true]}
      listeAAfficher.sort! {|a,b| a.filtreDeComptage <=> b.filtreDeComptage}
    end
  
    def definitLawebDialogue
      pagehtml="
      <html xmlns=\"http://www.w3.org/1999/xhtml\">\n
      <STYLE type=\"text/css\">\n        
        table {\n
    			border:2px solid #000;\n
    			border-collapse:collapse;\n
    			background-color: white;\n
    			margin-left:auto;\n
    			margin-right:auto;\n
    			width: 100%;\n
    			filter: alpha(opacity=60);\n
    			-moz-opacity:0.6;\n
    			opacity: 0.6;\n
    		}\n\n

    		td {\n 
    			vertical-align:middle;\n
    		}
    		.niveau1 {background-color: rgb(255,255,255);}
    		.niveau2 {background-color: rgb(245,245,245);}
    		.niveau3 {background-color: rgb(235,235,235);}
    		.niveau4 {background-color: rgb(225,225,225);}
    		.niveau5 {background-color: rgb(215,215,215);}
    		.niveau6 {background-color: rgb(205,205,205);}
    		.niveau7 {background-color: rgb(195,195,195);}
    		.niveau8 {background-color: rgb(185,185,185);}
    		.niveau9 {background-color: rgb(175,175,175);}        

      </STYLE>
  	  <head>\n
  		<title>Optisketch</title>\n
  		<script type=\"text/javascript\">
  			function beginexport()
  			{
  				window.location = 'skp:begin_export@';
  			}         
      </script>
		
  		</head>\n
  		<body>
  		<input type=\"submit\" onclick=\"beginexport();\" value=\"Export CSV\" />
  		<table>"
  		pagehtml += @listeLignes[0].getheader
  		@listeAAfficher = @listeLignes.select{|ligne| [ligne.aCompter,ligne.aAfficher] == [true,true]}
  		@listeAAfficher.sort!{|a,b| a.longueur <=> b.longueur}
  		@listeAAfficher.reverse!
  		@listeAAfficher.each{|ligne| pagehtml += ligne.gethtml}
  		pagehtml += "</table></body></html>"
  		#puts pagehtml.to_s
  		return pagehtml
    end
  
    def afficheLaWebDialogue
  		wbresult = UI::WebDialog.new("< ADEBEO - Zuschneideliste >", true, "", 600, 1200, 310, 180, true)
  		wbresult.set_html(@html)
  		@@adebeoOptiSketchCSV = ""
  		wbresult.add_action_callback("begin_export") {|d, arg|
    		exportCSV
    		wbresult.close
    	}
  		wbresult.show
				
  	end
 
    def exportCSV()
    
      mpath = Sketchup.active_model.path.split(".")[0]
      if mpath == ""
        UI.messagebox("Modell Zuerst Speichern.")
        return nil
      end
      csvpat = mpath+".csv"

      csvComplet = ""
      @listeAAfficher.each{|ligne|csvComplet+=ligne.getCSV}
      csvFile=File.new(csvpat,"w")
  		csvFile.puts(csvComplet)
  		csvFile.close
		
  		if @@options[:panneaux][:defauls] == 1
  		  largexport = "PceBar"
  		else
  		  largexport = "PcePan"
  		end
  		chemin = @@options[:cheminOpticoupe][:defauls].to_s.lstrip.to_s()
  		macommande = "\""+chemin+"\""+" /Import:"+largexport.to_s+"=\""+csvpat.to_s+"\" /ShowPce"
  		mocommande = macommande.to_s().tr("\\","/") 

  		system macommande.to_s
		
    end

  end

  def optiskethRapport
    rapport = RapportAdebeo.new
  end

end